<?php
  
class GoogleOpenID
{
    /*const*/var $URL = "https://www.google.com/accounts/o8/ud";
    
    /*private*/var $return_to;
    /*private*/var $realm;
    
    function /*__construct*/ GoogleOpenID($return_to, $realm)
    {
        $this->return_to = $return_to;
        $this->realm = $realm;
    }
    
    function GetURL()
    {
        return $this->URL;
    }
    
    function GetParts()
    {
        $ret = array(
            'openid.ns' => 'http://specs.openid.net/auth/2.0',
            'openid.claimed_id' => 'http://specs.openid.net/auth/2.0/identifier_select',
            'openid.identity' => 'http://specs.openid.net/auth/2.0/identifier_select',
            'openid.return_to' => $this->return_to,
            'openid.realm' => $this->realm,
            'openid.mode' => 'checkid_setup',
            'openid.ns.ext1' => 'http://openid.net/srv/ax/1.0',
            'openid.ext1.mode' => 'fetch_request',
            'openid.ext1.type.email' => 'http://schema.openid.net/contact/email',
            'openid.ext1.required' => 'email',
        );
        return $ret;
    }
    
}
  
class GoogleOpenIDResponse
{
    /*private*/var $query_string;
    
    /*private*/var $email;
    /*private*/var $identity;
    
    function /*__construct*/GoogleOpenIDResponse($query_string = FALSE)
    {
        if($query_string == FALSE)
            $query_string = $_SERVER['QUERY_STRING'];
            
        $this->query_string = str_replace('id_res', 'check_authentication', $query_string);
        
        $this->email = FALSE;
        $this->identity = FALSE;
    }    
    
    /*private*/ function ParseQueryString()
    {
        parse_str($this->query_string, $parts);
        //print_r($parts);
        
        $this->identity = $parts['openid_identity'];
        
        if(isset($parts['openid_ext1_value_email'])){
            $this->email = $parts['openid_ext1_value_email'];
        }
    }
    
    /*
        Google only populates the email field the first time
        a user authenticates with your site or when the email changes. 
    */
    function GetEmail()
    {
        return $this->email;
    }

    function GetIdentity()
    {
        return $this->identity;
    }    

    function Confirm()
    {
        //http://groups.google.com/group/google-federated-login-api/browse_thread/thread/5e93c8a1378e9d34
     
        // php4 doesn't support static variables
        $foo = new GoogleOpenID('', '');
      
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $foo->GetURL()); 
        curl_setopt($ch, CURLOPT_POSTFIELDS, $this->query_string);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
        curl_setopt($ch, CURLOPT_POST, 1);
        $data = curl_exec($ch);
        curl_close($ch);    
        
        $valid = FALSE;
        
        // XXX assumes the string 'is_valid:true' appears
        // no where else in the response, ever (which I believe is true)
        if(strpos($data, 'is_valid:true') !== FALSE){
            $valid = TRUE;
            $this->ParseQueryString();
        }
        
        return $valid;
    }   
}
  
