<?php
  
class GoogleUserManager
{
    var $Context;
    var $GLDB;
    
    function GoogleUserManager()
    {
        $this->Context = GLgetContext();
        $this->GLDB = new GLDB();
    }
    
    /*public static*/ function GetUserId($identity, $email = FALSE)
    {
        $this->RemoveDeletedUsers();
        
        $user_id = FALSE;

        $pre = $this->Context->Configuration['DATABASE_TABLE_PREFIX'];
        $result = $this->GLDB->Query("SELECT * from `{$pre}GLUserGoogleIdentity` where google_identity = '?'", $identity);
        
        
        if(count($result) == 0){
            // new user
            $user_id = $this->CreateUser($identity, $email);
        
        }else{
            // existing user
            $user_id = $result[0]->user_id;
        }
        
        
        return $user_id;
        
    }
    
    // utility function to remove deleted users from database. 
    /*public static*/ function RemoveDeletedUsers()
    {
        $pre = $this->Context->Configuration['DATABASE_TABLE_PREFIX'];
        
        $result = $this->GLDB->Query("select * from {$pre}GLUserGoogleIdentity left outer join {$pre}User on user_id = UserId where UserId is NULL");
        
        foreach($result as $user)
            $this->GLDB->Query("delete from {$pre}GLUserGoogleIdentity where user_id = ?", $user->user_id);
    }
    
    // add user to vanilla user table and to our own
    // and return user_id
    /*public static*/ function CreateUser($identity, $email)
    {
        
        if($email === FALSE)
            $email = '';
                
        $pre = $this->Context->Configuration['DATABASE_TABLE_PREFIX'];
                
        $this->GLDB->Insert("{$pre}User",
                     array(
                        'RoleID'    => '3',
                        'FirstName' => '',
                        'LastName'  => '',
                        'Name'      => $email,
                        'DateFirstVisit' => MysqlDateTime(),
                        'Password'  => sha1(uniqid(rand(), true)), // something random we don't care about
                        'Email' => $email,
                     ));
               
        $user_id = $this->GLDB->GetInsertId();
        
        $this->GLDB->Insert("{$pre}GLUserGoogleIdentity",
                     array(
                        'user_id' => $user_id,
                        'google_identity' => $identity,
                        'email' => $email));
                        
        return $user_id;
    }
    
    
    // Warning: This function logs a user in as $user_id without
    // requiring a password. Use at your own risk. 
    /*public static*/ function Login($user_id)
    {
        
        // duplicating the necessary functionality from People.Class.Authenticator.php:Authenticate
        
        //$VerificationKey = $User->VerificationKey;
		$UserManager = $this->Context->ObjectFactory->NewContextObject($this->Context, 'UserManager');
		
		$User = $UserManager->GetUserById($user_id);
		
        if ($User->VerificationKey == '')
            $User->VerificationKey = DefineVerificationKey();
		
		
		$VerificationKey = $User->VerificationKey;
		
        // 1. Update the user's information
        $UserManager->UpdateUserLastVisit($user_id, $VerificationKey);


        // 2. Log the user's IP address
        $UserManager->AddUserIP($user_id);

        // Assign the session value
        $this->Context->Authenticator->AssignSessionUserID($user_id);
        
        // Set the 'remember me' cookies
        $this->Context->Authenticator->SetCookieCredentials($user_id, $VerificationKey);        
    }

}
  
