<?php
/*
Extension Name: GoogleLogin
Extension Url: http://from.bz
Description: Lets users log in using their Google Accounts
Version: .1
Author: Bill Zeller
Author Url: http://from.bz
*/

if(!function_exists('curl_init')){
    echo 'GoogleLogin: The CURL library is required for this addon to work.<br>';
    echo 'Please add CURL or disable the GoogleLogin addon';
}else{

    // start setup
    include_once($Configuration['EXTENSIONS_PATH'].'GoogleLogin/util.php');
    include_once(GLGetPath('GLDB.php'));
    include_once(GLGetPath('dbconfig.php'));

    /////////////// start routing

    if(GLConfigGet('VERSION') === FALSE)
    {
        GLConfigAdd('VERSION', '.1');
        
        $GLDB = new GLDB();
        foreach($GL_tables as $table)
        {
            $GLDB->Query($table);
        }
      
    }


    if(ForceIncomingString('GLPostBackAction', '') == 'GLcheck')
    {
        include_once(GLGetPath('GoogleOpenID.php'));
        
        //include_once(GLGetPath('GoogleOpenID.php'));

        //$goi = GoogleOpenID::getResponse();

        $goir = new GoogleOpenIDResponse();
        if($goir->Confirm()){
            include_once(GLGetPath('GoogleUserManager.php'));
            $gum = new GoogleUserManager();
            $user_id = $gum->GetUserId($goir->GetIdentity(), $goir->GetEmail());
            $gum->Login($user_id);
            header("Location: ".GetUrl($Configuration, 'index.php', '', '', '', '', ''));
            exit;
        }else{
            $Context->WarningCollector->Add('Your Google account was not authenticated.');
        }
        
    }



    if($Context->SelfUrl == "people.php"){
        $Context->AddToDelegate('SignInForm', 'PreNoPostBackRender', 'signin_prerender');
    }


    /////////////// start functions related to this plugin


    function signin_prerender(&$SignInForm)
    {
        include_once(GLGetPath('GoogleOpenID.php'));
        
        $googleIMGURL = GLGetWebPath('images/google.png');
        
        $config = GLgetConfig();
        $return_to = $config['BASE_URL'].'people.php?GLPostBackAction=GLcheck';
        
        $url_parts = parse_url($config['BASE_URL']);
        $realm = $url_parts['scheme'].'://'.$url_parts['host'].'/';
        
        
        $goi = new GoogleOpenID($return_to, $realm);
        
        $url = $goi->GetURL();
        
        $parts = $goi->GetParts();

        echo "<form action=\"$url\" method=\"POST\">";
        foreach($parts as $name=>$value)
            echo "<input type=\"hidden\" name=\"$name\" value=\"$value\">\n";

        echo <<<EOT
    <div style="width:100%;text-align:center;padding-bottom:5px">
    <img src="$googleIMGURL">
    <br/>

    <input type="submit" value="Sign in with Google "/>

        <br>
        <br>
        or use a username and password below...

    </div>
    </form>
EOT;
        
    }

}
